# Computer Networks

Zoom link: https://liu-se.zoom.us/j/6203044806

Passcode: 345609

Welcome to the repository of the *TDDE35: Large-Scale Distributed Systems and Networks* courses!

<!---[TDDE35: Large-Scale Distributed Systems and Networks](https://www.ida.liu.se/~TDDE35/labs/)-->

This course has 4 lab assignments:
* [Assignment 1: Wireshark lab. Getting started + HTTP](https://gitlab.liu.se/lemi44/networks/-/tree/master/lab1-wireshark)
* [Assignment 2: Net Ninny. A Web Proxy Based Service](https://gitlab.liu.se/lemi44/networks/-/tree/master/lab2-proxy)
* [Assignment 3: Transmission Control Protocol (TCP)](https://gitlab.liu.se/lemi44/networks/-/tree/master/lab3-tcp)
* [Assignment 4: Distance Vector Routing](https://gitlab.liu.se/nikko22/lemi44/-/tree/master/lab4-routing)

**Read this file till the end! Assignments that are handed in incorrectly will be automatically rejected.**

Assignment instructions can be found on the web-page for your course code (e.g. [TDDE35](https://www.ida.liu.se/~TDDE35/labs/)).
Additional submission and report requirements are located in subfolders (e.g. [networks/lab1-wireshark](https://gitlab.liu.se/lemi44/networks/-/tree/master/lab1-wireshark), [networks/lab2-proxy](https://gitlab.liu.se/lemi44/networks/-/tree/master/lab2-proxy), etc.).


Submit solutions and reports using **your gitlab repository, which must be a *private* fork of the repository [lemi44/networks](https://gitlab.liu.se/lemi44/networks)**. A fork is essentially a copy of a repository that is cloned into your own account.

These instructions describe how to (i) create a forked repository and (ii) hand-in assignments via the repository and email.

Also, see [Virtual lab sessions](https://gitlab.liu.se/lemi44/networks/-/issues/1).


## Getting started

### 0. Log into gitlab.liu.se with your LiU-ID

### 1. Fork the repository [lemi44/networks](https://gitlab.liu.se/lemi44/networks)

Press the "Fork" button on the top of this page to copy this repository to your account.


> <img src="/pictures/fork_image.png"  width="500"> 
---

Then, on the next page that pops up, choose your account:


> <img src="/pictures/fork2_image.png"  width="500"> 
---

After successfully forking the repository, you will see the following message:


> <img src="/pictures/fork3_image.png"  width="500"> 
---

### 2. Make your fork private!

Your forked repository **must be made private**.

Find the "Settings" button on the left side of the forked repository's main page, and click 'General' to change the permissions of your project.

> <img src="/pictures/change_permission1.png"  width="500"> 
---
Expand 'Permissions', set 'Project visibility' to 'Private', and then save changes.

> <img src="/pictures/change_permission2.png"  width="500"> 
---
### 3. **Provide "Maintainer" access to your partner and your lab assistant**

Find the "Settings" button on the left side of the forked repository's main page, and click 'Members' to add people who can access your repository.

> <img src="/pictures/add_member1.png"  width="500"> 
---
Provide **"Maintainer"** access to your lab partner and to your lab assistant

> <img src="/pictures/add_member2.png"  width="500"> 
---

### 4. Work on the assignments

You may want to download the content of your repository to work on the lab assignments. If you are familiar with [git](https://en.wikipedia.org/wiki/Git), then you can use it to work with your forked repository. Otherwise, it is perhaps easier to use the download option on the main page of the repository.

> <img src="/pictures/download.png"  width="500"> 
---
After downloading the contents of your repository, you can start working on the assignments. The repository contains 4 assignment folders. **Check out assignment folders for submission instructions.**

### 5. Place your code and a report into the forked repository
After completing an assignment, edit/upload the files to your forked repository.

If there exists an example report in a lab folder, then you can edit it in your browser:

> <img src="/pictures/edit.png"  width="500"> 
---
Or, you can also upload files to the folders of your repository:

> <img src="/pictures/upload.png"  width="500"> 
---

### 6. Demonstrate your assignment during a lab session
See [Virtual lab sessions](https://gitlab.liu.se/lemi44/networks/-/issues/1).

---

### 7. Submit/re-submit by sending an email with a link to your repository
To submit/resubmit an assignment, *email an address of your repository* to your lab assistant. The subject of the email letter *must* adhere to the following pattern: 
* **CourseCode_Year_labNumber_userName1_userName2** 
(e.g., TDDE35_2020_lab4_hrsdv94_dgjjt92).

> <img src="/pictures/email.png"  width="500"> 
